drupal_parse_url

Versions
7
drupal_parse_url($url)

Wrapper around parse_url() to parse a system URL string into an associative array, suitable for url().

This function should only be used for URLs that have been generated by the system, resp. url(). It should not be used for URLs that come from external sources, or URLs that link to external resources.

The returned array contains a 'path' that may be passed separately to url(). For example:

<?php

$options = drupal_parse_url($_GET['destination']);
$my_url = url($options['path'], $options);
$my_link = l('Example link', $options['path'], $options);

?>

This is required, because url() does not support relative URLs containing a query string or fragment in its $path argument. Instead, any query string needs to be parsed into an associative query parameter array in $options['query'] and the fragment into $options['fragment'].

See also

url()

@see drupal_goto()

Parameters

$url The URL string to parse, f.e. $_GET['destination'].

Return value

An associative array containing the keys:

  • 'path': The path of the URL. If the given $url is external, this includes the scheme and host.
  • 'query': An array of query parameters of $url, if existent.
  • 'fragment': The fragment of $url, if existent.

Related topics

▾ 2 functions call drupal_parse_url()

confirm_form in modules/system/system.module
Output a confirmation form
drupal_goto in includes/common.inc
Send the user to a different Drupal page.

Code

includes/common.inc, line 576

<?php
function drupal_parse_url($url) {
  $options = array(
    'path' => NULL,
    'query' => array(),
    'fragment' => '',
  );

  // External URLs: not using parse_url() here, so we do not have to rebuild
  // the scheme, host, and path without having any use for it.
  if (strpos($url, '://') !== FALSE) {
    // Split off everything before the query string into 'path'.
    $parts = explode('?', $url);
    $options['path'] = $parts[0];
    // If there is a query string, transform it into keyed query parameters.
    if (isset($parts[1])) {
      $query_parts = explode('#', $parts[1]);
      parse_str($query_parts[0], $options['query']);
      // Take over the fragment, if there is any.
      if (isset($query_parts[1])) {
        $options['fragment'] = $query_parts[1];
      }
    }
  }
  // Internal URLs.
  else {
    // parse_url() does not support relative URLs, so make it absolute. E.g. the
    // relative URL "foo/bar:1" isn't properly parsed.
    $parts = parse_url('http://example.com/' . $url);
    // Strip the leading slash that was just added.
    $options['path'] = substr($parts['path'], 1);
    if (isset($parts['query'])) {
      parse_str($parts['query'], $options['query']);
    }
    if (isset($parts['fragment'])) {
      $options['fragment'] = $parts['fragment'];
    }
  }
  // The 'q' parameter contains the path of the current page if clean URLs are
  // disabled. It overrides the 'path' of the URL when present, even if clean
  // URLs are enabled, due to how Apache rewriting rules work.
  if (isset($options['query']['q'])) {
    $options['path'] = $options['query']['q'];
    unset($options['query']['q']);
  }

  return $options;
}
?>
Login or register to post comments
 
 

All source code and documentation on this site is released under the terms of the GNU General Public License, version 2 and later. Drupal is a registered trademark of Dries Buytaert.